查询当前文档所有块表记录名称(blocktablerecord)及模型空间中实体对象—— cad c# 二次开发

发布于:2025-02-11 ⋅ 阅读:(15) ⋅ 点赞:(0)

运行dll文件,查询结果输出到命令行。

效果如下:

using Autodesk.AutoCAD.ApplicationServices;
using Autodesk.AutoCAD.DatabaseServices;
using Autodesk.AutoCAD.EditorInput;
using Autodesk.AutoCAD.Geometry;
using Autodesk.AutoCAD.Runtime;
using System;
using System.Collections.Generic;
using System.Drawing;
using System.Globalization;
using System.IO;
using System.Linq;
using System.Security.Cryptography;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Forms;
using Application = Autodesk.AutoCAD.ApplicationServices.Application;

namespace AcTools
{
    public class Class1
    {
        [CommandMethod("xx")]
        public void XX()
        {
            Document doc = Application.DocumentManager.MdiActiveDocument;
            Database db = doc.Database;
            Editor editor = doc.Editor;
            using (Transaction tr = db.TransactionManager.StartTransaction())
            {
                // Open the Block table for read
                BlockTable bt = tr.GetObject(db.BlockTableId, OpenMode.ForRead) as BlockTable;
                int count = 0;
                foreach (ObjectId blkId in bt)
                {
                    count += 1;
                    BlockTableRecord blkRec = tr.GetObject(blkId, OpenMode.ForRead) as BlockTableRecord;
                    editor.WriteMessage($"\n第{count}个快表记录:...... {blkRec.Name}\n");
                  
                    // Optionally, iterate through the block contents
                    int entcount = 0;
                    foreach (ObjectId objId in blkRec)
                    {
                        entcount +=1;
                        Entity entity = tr.GetObject(objId, OpenMode.ForRead) as Entity;
                        if (entity != null)
                        {
                            editor.WriteMessage($" 包含内容{entcount}: Entity Type: {entity.GetType().Name}, ID: {objId}\n");
                        }
                    }
                }

                tr.Commit();
                editor.WriteMessage($" \n作者山水qq443440204\n");
            }
        }
      
    }
  
}